<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Recent_sales extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        $this->load->library('multiquery');  
    }

    public function index(){
    	$state = @$this->input->get('state');
    	$region_name = @urldecode($this->input->get('region'));
    	$rep = @$this->input->get('rep');
        $region ="";
        if($region_name){
            $this->db->where('regionname',$region_name);
            $data7 = $this->db->get('ptsl_region')->result_array();
            $region = $data7[0]['id'];
        }
        $data_mdate = $this->db->query('SELECT max(raw_date)  as mdate FROM ptsl_sales_transactions')->result_array();
        $max_date = $data_mdate[0]['mdate'];
    	/*$this->db->select('tran.brand_and_packaging as sku,tran.raw_account_name as LongName,date_format(tran.raw_date,"%M %d, %Y") as date,rep.ClientRepName');
    	$this->db->from(' ptsl_sales_transactions tran');
    	$this->db->join('ptsl_clientrep rep','rep.ClientRepID= tran.client_rep_id','');
    	$data = $this->db->get()->result_array();*/
    	$sql = "SELECT `tran`.`brand_and_packaging` as `sku`,tran.units as unit,  `tran`.`raw_account_name` as `LongName`, date_format(tran.raw_date, '%M %d, %Y') as date, `rep`.`ClientRepName`
			FROM `ptsl_sales_transactions` `tran`
			JOIN `ptsl_clientrep` `rep` ON `rep`.`ClientRepID`= `tran`.`client_rep_id` where raw_date >= DATE('".$max_date."') - INTERVAL 7 DAY";
		if($region && $state && $rep){ //111
			$sql = $sql.' and tran.region='.$region.' and tran.raw_state="'.$state.'" and tran.client_rep_id='.$rep ;	
		}
		if($region && !$state && !$rep){ //100
			$sql = $sql.' and tran.region='.$region;
		}
		if($region && $state && !$rep){ //110
			$sql = $sql.' and tran.region='.$region.' and tran.raw_state="'.$state.'"';
		}
		if($region && !$state && $rep){//101
			$sql = $sql.' and tran.client_rep_id='.$rep.' and tran.region='.$region;
		}
		if(!$region && !$state && $rep){//001
			$sql = $sql.' and tran.client_rep_id='.$rep;
		}
		if(!$region && $state && $rep){//011
			$sql = $sql.' and tran.raw_state="'.$state.'" and tran.client_rep_id='.$rep;
		}
		if(!$region && $state && !$rep){//010
			$sql = $sql.' and tran.raw_state="'.$state.'"';
		}
        $sql = $sql.' order by tran.raw_date desc,tran.order_id desc ';	
    	$data = $this->db->query($sql)->result_array();

    	if($data){
    		$response = array(
    			'status' => TRUE,
    			'recent_sales' => $data
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status' => FALSE,
    			'message' => 'No data Found'
    		);
    		echo json_encode($response);
    	}
    }
    public function filter_v2(){
        $user_id = @$this->input->get('user_id');
        $type = @$this->input->get('type');
        $brand = @$this->input->get('brand');
        $sku = @$this->input->get('sku');
        $time_frame = @$this->input->get('time_frame');
        $state = @$this->input->get('state');
        $range = @$this->input->get('range');
        $region = @$this->input->get('region');
        $rep = @$this->input->get('rep');
        if(!$range){
            $range = 7;
        }else{
            $range = $range;
        }
        
        $spn= "Call ptsl_sp_get_recent_sales(
                '".$user_id."',
                '".$region."',
                '".$state."',
                '".$rep."',
                '".$type."',
                '".$brand."',
                '".$sku."',
                '".$time_frame."
             ')";

        $data = $this->multiquery->GetResults($spn);
        //print_r($data);
        //echo $spn;
        if($data){
            $cnt = 0;
            if($data[3]){
                foreach($data[3] as $key=>$rec_data){
                $name = $rec_data['LongName'];
                $address = $rec_data['full_address'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$rec_data["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $rec_data['latitude'];
                $geocode_array[$cnt][2] = $rec_data['longitude'];
                $cnt++;
            }
        
            $response = array(
                'status' => TRUE,
                'recent_sales' => $data[3],
                'locations' => $geocode_array
            );
            echo json_encode($response);
            }else{
                $response = array(
                    'status' => FALSE,
                    'message' => 'No data Found'
                );
                echo json_encode($response);
            }
            
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
         
    }
    public function search_brands(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $spn = "Call ptsl_get_item_brand('".$post_data['user_id']."','".$post_data['key']."')";
        $data = $this->db->query($spn)->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'brands' => $data,
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }

    }
    public function search_sku(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $spn = "Call ptsl_get_item_sku('".$post_data['user_id']."','".$post_data['key']."')";
        $data = $this->db->query($spn)->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'skus' => $data,
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }

    }

}